﻿Imports System.Text
Imports System.Collections.ObjectModel
Imports System.ComponentModel

Namespace WpfApplication1
	''' <summary>
	''' Interaction logic for MainWindow.xaml
	''' </summary>
	Partial Public Class MainWindow
		Inherits Window
		Public Sub New()
			InitializeComponent()
			Me.DataContext = New ShellViewModel()
		End Sub
	End Class

	Public Class ShellViewModel
		Inherits ViewModelBase
		Private _currentview As ViewModelBase
		Private _openviews As ObservableCollection(Of ViewModelBase)

		Public ReadOnly Property Views() As ObservableCollection(Of ViewModelBase)
			Get
				If _openviews Is Nothing Then
					_openviews = New ObservableCollection(Of ViewModelBase)()
					LoadDefaultViews()
				End If
				Return _openviews
			End Get
		End Property

		Private Sub LoadDefaultViews()
			_openviews.Add(New DeviceInventoryListViewModel())
			_openviews.Add(New AccountMaintenanceListViewModel())
			_currentview = _openviews(0)
		End Sub


		Public Property SelectedView() As ViewModelBase
			Get
				Return _currentview
			End Get
			Set(ByVal value As ViewModelBase)
				_currentview = value
				OnPropertyChanged("SelectedView")
			End Set
		End Property
	End Class

	Public Class ViewModelBase
		Implements INotifyPropertyChanged
		Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged

		Public Sub OnPropertyChanged(ByVal propertyName As String)
			RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(propertyName))
		End Sub
	End Class

	Public Class DeviceInventoryListViewModel
		Inherits ViewModelBase
	End Class

	Public Class AccountMaintenanceListViewModel
		Inherits ViewModelBase
	End Class
End Namespace
